# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class AnalyticsProduct(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'catalog_id': 'int',
        'units_sold': 'AnalyticsDataPointWithTrend'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'catalog_id': 'catalogId',
        'units_sold': 'unitsSold'
    }

    def __init__(self, id=None, name=None, catalog_id=None, units_sold=None, local_vars_configuration=None):  # noqa: E501
        """AnalyticsProduct - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._catalog_id = None
        self._units_sold = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.catalog_id = catalog_id
        if units_sold is not None:
            self.units_sold = units_sold

    @property
    def id(self):
        """Gets the id of this AnalyticsProduct.  # noqa: E501

        The ID of the product.  # noqa: E501

        :return: The id of this AnalyticsProduct.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AnalyticsProduct.

        The ID of the product.  # noqa: E501

        :param id: The id of this AnalyticsProduct.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this AnalyticsProduct.  # noqa: E501

        The name of the product.  # noqa: E501

        :return: The name of this AnalyticsProduct.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AnalyticsProduct.

        The name of the product.  # noqa: E501

        :param name: The name of this AnalyticsProduct.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def catalog_id(self):
        """Gets the catalog_id of this AnalyticsProduct.  # noqa: E501

        The ID of the catalog. You can find the ID in the Campaign Manager in **Account** > **Tools** > **Cart item catalogs**.   # noqa: E501

        :return: The catalog_id of this AnalyticsProduct.  # noqa: E501
        :rtype: int
        """
        return self._catalog_id

    @catalog_id.setter
    def catalog_id(self, catalog_id):
        """Sets the catalog_id of this AnalyticsProduct.

        The ID of the catalog. You can find the ID in the Campaign Manager in **Account** > **Tools** > **Cart item catalogs**.   # noqa: E501

        :param catalog_id: The catalog_id of this AnalyticsProduct.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and catalog_id is None:  # noqa: E501
            raise ValueError("Invalid value for `catalog_id`, must not be `None`")  # noqa: E501

        self._catalog_id = catalog_id

    @property
    def units_sold(self):
        """Gets the units_sold of this AnalyticsProduct.  # noqa: E501


        :return: The units_sold of this AnalyticsProduct.  # noqa: E501
        :rtype: AnalyticsDataPointWithTrend
        """
        return self._units_sold

    @units_sold.setter
    def units_sold(self, units_sold):
        """Sets the units_sold of this AnalyticsProduct.


        :param units_sold: The units_sold of this AnalyticsProduct.  # noqa: E501
        :type: AnalyticsDataPointWithTrend
        """

        self._units_sold = units_sold

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AnalyticsProduct):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AnalyticsProduct):
            return True

        return self.to_dict() != other.to_dict()
