# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ApplicationCIFReferences(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'application_cart_item_filter_id': 'int',
        'campaigns': 'list[CampaignDetail]'
    }

    attribute_map = {
        'application_cart_item_filter_id': 'applicationCartItemFilterId',
        'campaigns': 'campaigns'
    }

    def __init__(self, application_cart_item_filter_id=None, campaigns=None, local_vars_configuration=None):  # noqa: E501
        """ApplicationCIFReferences - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._application_cart_item_filter_id = None
        self._campaigns = None
        self.discriminator = None

        if application_cart_item_filter_id is not None:
            self.application_cart_item_filter_id = application_cart_item_filter_id
        if campaigns is not None:
            self.campaigns = campaigns

    @property
    def application_cart_item_filter_id(self):
        """Gets the application_cart_item_filter_id of this ApplicationCIFReferences.  # noqa: E501

        The ID of the Application Cart Item Filter that is referenced by a campaign.  # noqa: E501

        :return: The application_cart_item_filter_id of this ApplicationCIFReferences.  # noqa: E501
        :rtype: int
        """
        return self._application_cart_item_filter_id

    @application_cart_item_filter_id.setter
    def application_cart_item_filter_id(self, application_cart_item_filter_id):
        """Sets the application_cart_item_filter_id of this ApplicationCIFReferences.

        The ID of the Application Cart Item Filter that is referenced by a campaign.  # noqa: E501

        :param application_cart_item_filter_id: The application_cart_item_filter_id of this ApplicationCIFReferences.  # noqa: E501
        :type: int
        """

        self._application_cart_item_filter_id = application_cart_item_filter_id

    @property
    def campaigns(self):
        """Gets the campaigns of this ApplicationCIFReferences.  # noqa: E501

        Campaigns that reference a speciifc Application Cart Item Filter.  # noqa: E501

        :return: The campaigns of this ApplicationCIFReferences.  # noqa: E501
        :rtype: list[CampaignDetail]
        """
        return self._campaigns

    @campaigns.setter
    def campaigns(self, campaigns):
        """Sets the campaigns of this ApplicationCIFReferences.

        Campaigns that reference a speciifc Application Cart Item Filter.  # noqa: E501

        :param campaigns: The campaigns of this ApplicationCIFReferences.  # noqa: E501
        :type: list[CampaignDetail]
        """

        self._campaigns = campaigns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationCIFReferences):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationCIFReferences):
            return True

        return self.to_dict() != other.to_dict()
