# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CouponsNotificationPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'scopes': 'list[str]',
        'batching_enabled': 'bool',
        'include_data': 'bool',
        'batch_size': 'int'
    }

    attribute_map = {
        'name': 'name',
        'scopes': 'scopes',
        'batching_enabled': 'batchingEnabled',
        'include_data': 'includeData',
        'batch_size': 'batchSize'
    }

    def __init__(self, name=None, scopes=None, batching_enabled=True, include_data=None, batch_size=None, local_vars_configuration=None):  # noqa: E501
        """CouponsNotificationPolicy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._scopes = None
        self._batching_enabled = None
        self._include_data = None
        self._batch_size = None
        self.discriminator = None

        self.name = name
        self.scopes = scopes
        if batching_enabled is not None:
            self.batching_enabled = batching_enabled
        if include_data is not None:
            self.include_data = include_data
        if batch_size is not None:
            self.batch_size = batch_size

    @property
    def name(self):
        """Gets the name of this CouponsNotificationPolicy.  # noqa: E501

        Notification name.  # noqa: E501

        :return: The name of this CouponsNotificationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CouponsNotificationPolicy.

        Notification name.  # noqa: E501

        :param name: The name of this CouponsNotificationPolicy.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def scopes(self):
        """Gets the scopes of this CouponsNotificationPolicy.  # noqa: E501


        :return: The scopes of this CouponsNotificationPolicy.  # noqa: E501
        :rtype: list[str]
        """
        return self._scopes

    @scopes.setter
    def scopes(self, scopes):
        """Sets the scopes of this CouponsNotificationPolicy.


        :param scopes: The scopes of this CouponsNotificationPolicy.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and scopes is None:  # noqa: E501
            raise ValueError("Invalid value for `scopes`, must not be `None`")  # noqa: E501
        allowed_values = ["all", "campaign_manager", "management_api", "rule_engine"]  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                not set(scopes).issubset(set(allowed_values))):  # noqa: E501
            raise ValueError(
                "Invalid values for `scopes` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(scopes) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._scopes = scopes

    @property
    def batching_enabled(self):
        """Gets the batching_enabled of this CouponsNotificationPolicy.  # noqa: E501

        Indicates whether batching is activated.  # noqa: E501

        :return: The batching_enabled of this CouponsNotificationPolicy.  # noqa: E501
        :rtype: bool
        """
        return self._batching_enabled

    @batching_enabled.setter
    def batching_enabled(self, batching_enabled):
        """Sets the batching_enabled of this CouponsNotificationPolicy.

        Indicates whether batching is activated.  # noqa: E501

        :param batching_enabled: The batching_enabled of this CouponsNotificationPolicy.  # noqa: E501
        :type: bool
        """

        self._batching_enabled = batching_enabled

    @property
    def include_data(self):
        """Gets the include_data of this CouponsNotificationPolicy.  # noqa: E501

        Indicates whether to include all generated coupons. If `false`, only the `batchId` of the generated coupons is included.  # noqa: E501

        :return: The include_data of this CouponsNotificationPolicy.  # noqa: E501
        :rtype: bool
        """
        return self._include_data

    @include_data.setter
    def include_data(self, include_data):
        """Sets the include_data of this CouponsNotificationPolicy.

        Indicates whether to include all generated coupons. If `false`, only the `batchId` of the generated coupons is included.  # noqa: E501

        :param include_data: The include_data of this CouponsNotificationPolicy.  # noqa: E501
        :type: bool
        """

        self._include_data = include_data

    @property
    def batch_size(self):
        """Gets the batch_size of this CouponsNotificationPolicy.  # noqa: E501

        The required size of each batch of data. This value applies only when `batchingEnabled` is `true`.  # noqa: E501

        :return: The batch_size of this CouponsNotificationPolicy.  # noqa: E501
        :rtype: int
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """Sets the batch_size of this CouponsNotificationPolicy.

        The required size of each batch of data. This value applies only when `batchingEnabled` is `true`.  # noqa: E501

        :param batch_size: The batch_size of this CouponsNotificationPolicy.  # noqa: E501
        :type: int
        """

        self._batch_size = batch_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CouponsNotificationPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CouponsNotificationPolicy):
            return True

        return self.to_dict() != other.to_dict()
