# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class HiddenConditionsEffects(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'built_in_effects': 'list[str]',
        'conditions': 'list[str]',
        'custom_effects': 'list[int]',
        'webhooks': 'list[int]'
    }

    attribute_map = {
        'built_in_effects': 'builtInEffects',
        'conditions': 'conditions',
        'custom_effects': 'customEffects',
        'webhooks': 'webhooks'
    }

    def __init__(self, built_in_effects=None, conditions=None, custom_effects=None, webhooks=None, local_vars_configuration=None):  # noqa: E501
        """HiddenConditionsEffects - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._built_in_effects = None
        self._conditions = None
        self._custom_effects = None
        self._webhooks = None
        self.discriminator = None

        if built_in_effects is not None:
            self.built_in_effects = built_in_effects
        if conditions is not None:
            self.conditions = conditions
        if custom_effects is not None:
            self.custom_effects = custom_effects
        if webhooks is not None:
            self.webhooks = webhooks

    @property
    def built_in_effects(self):
        """Gets the built_in_effects of this HiddenConditionsEffects.  # noqa: E501

        List of hidden built-in effects.  # noqa: E501

        :return: The built_in_effects of this HiddenConditionsEffects.  # noqa: E501
        :rtype: list[str]
        """
        return self._built_in_effects

    @built_in_effects.setter
    def built_in_effects(self, built_in_effects):
        """Sets the built_in_effects of this HiddenConditionsEffects.

        List of hidden built-in effects.  # noqa: E501

        :param built_in_effects: The built_in_effects of this HiddenConditionsEffects.  # noqa: E501
        :type: list[str]
        """

        self._built_in_effects = built_in_effects

    @property
    def conditions(self):
        """Gets the conditions of this HiddenConditionsEffects.  # noqa: E501

        List of hidden conditions.  # noqa: E501

        :return: The conditions of this HiddenConditionsEffects.  # noqa: E501
        :rtype: list[str]
        """
        return self._conditions

    @conditions.setter
    def conditions(self, conditions):
        """Sets the conditions of this HiddenConditionsEffects.

        List of hidden conditions.  # noqa: E501

        :param conditions: The conditions of this HiddenConditionsEffects.  # noqa: E501
        :type: list[str]
        """

        self._conditions = conditions

    @property
    def custom_effects(self):
        """Gets the custom_effects of this HiddenConditionsEffects.  # noqa: E501

        List of the IDs of hidden custom effects.  # noqa: E501

        :return: The custom_effects of this HiddenConditionsEffects.  # noqa: E501
        :rtype: list[int]
        """
        return self._custom_effects

    @custom_effects.setter
    def custom_effects(self, custom_effects):
        """Sets the custom_effects of this HiddenConditionsEffects.

        List of the IDs of hidden custom effects.  # noqa: E501

        :param custom_effects: The custom_effects of this HiddenConditionsEffects.  # noqa: E501
        :type: list[int]
        """

        self._custom_effects = custom_effects

    @property
    def webhooks(self):
        """Gets the webhooks of this HiddenConditionsEffects.  # noqa: E501

        List of the IDs of hidden webhooks.  # noqa: E501

        :return: The webhooks of this HiddenConditionsEffects.  # noqa: E501
        :rtype: list[int]
        """
        return self._webhooks

    @webhooks.setter
    def webhooks(self, webhooks):
        """Sets the webhooks of this HiddenConditionsEffects.

        List of the IDs of hidden webhooks.  # noqa: E501

        :param webhooks: The webhooks of this HiddenConditionsEffects.  # noqa: E501
        :type: list[int]
        """

        self._webhooks = webhooks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HiddenConditionsEffects):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HiddenConditionsEffects):
            return True

        return self.to_dict() != other.to_dict()
