# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class RevisionActivationRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'user_ids': 'list[int]',
        'activate_at': 'datetime'
    }

    attribute_map = {
        'user_ids': 'userIds',
        'activate_at': 'activateAt'
    }

    def __init__(self, user_ids=None, activate_at=None, local_vars_configuration=None):  # noqa: E501
        """RevisionActivationRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._user_ids = None
        self._activate_at = None
        self.discriminator = None

        self.user_ids = user_ids
        if activate_at is not None:
            self.activate_at = activate_at

    @property
    def user_ids(self):
        """Gets the user_ids of this RevisionActivationRequest.  # noqa: E501

        The list of IDs of the users who will receive the activation request.  # noqa: E501

        :return: The user_ids of this RevisionActivationRequest.  # noqa: E501
        :rtype: list[int]
        """
        return self._user_ids

    @user_ids.setter
    def user_ids(self, user_ids):
        """Sets the user_ids of this RevisionActivationRequest.

        The list of IDs of the users who will receive the activation request.  # noqa: E501

        :param user_ids: The user_ids of this RevisionActivationRequest.  # noqa: E501
        :type: list[int]
        """
        if self.local_vars_configuration.client_side_validation and user_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `user_ids`, must not be `None`")  # noqa: E501

        self._user_ids = user_ids

    @property
    def activate_at(self):
        """Gets the activate_at of this RevisionActivationRequest.  # noqa: E501

        Time when the revisions are finalized after the `activate_revision` operation. The current time is used when left blank.  **Note:** It must be an RFC3339 timestamp string.   # noqa: E501

        :return: The activate_at of this RevisionActivationRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._activate_at

    @activate_at.setter
    def activate_at(self, activate_at):
        """Sets the activate_at of this RevisionActivationRequest.

        Time when the revisions are finalized after the `activate_revision` operation. The current time is used when left blank.  **Note:** It must be an RFC3339 timestamp string.   # noqa: E501

        :param activate_at: The activate_at of this RevisionActivationRequest.  # noqa: E501
        :type: datetime
        """

        self._activate_at = activate_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RevisionActivationRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RevisionActivationRequest):
            return True

        return self.to_dict() != other.to_dict()
