# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import talon_one
from talon_one.models.customer_inventory import CustomerInventory  # noqa: E501
from talon_one.rest import ApiException

class TestCustomerInventory(unittest.TestCase):
    """CustomerInventory unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test CustomerInventory
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = talon_one.models.customer_inventory.CustomerInventory()  # noqa: E501
        if include_optional :
            return CustomerInventory(
                profile = talon_one.models.customer_profile.CustomerProfile(
                    id = 6, 
                    created = '2020-02-07T08:15:22Z', 
                    integration_id = 'URNGV8294NV', 
                    attributes = {"Language":"english","ShippingCountry":"DE"}, 
                    account_id = 31, 
                    closed_sessions = 3, 
                    total_sales = 299.99, 
                    loyalty_memberships = [
                        talon_one.models.loyalty_membership.LoyaltyMembership(
                            joined = '2012-03-20T14:15:22Z', 
                            loyalty_program_id = 323414846, )
                        ], 
                    audience_memberships = [
                        talon_one.models.audience_membership.AudienceMembership(
                            id = 2, 
                            name = 'Travel audience', )
                        ], 
                    last_activity = '2020-02-08T14:15:20Z', 
                    sandbox = False, ), 
                loyalty = talon_one.models.loyalty.Loyalty(
                    cards = [
                        talon_one.models.loyalty_card.LoyaltyCard(
                            id = 6, 
                            created = '2020-06-10T09:05:27.993483Z', 
                            program_id = 125, 
                            program_name = 'Loyalty_program', 
                            program_title = 'Loyalty program', 
                            status = 'active', 
                            block_reason = 'Current card lost. Customer needs a new card.', 
                            identifier = 'summer-loyalty-card-0543', 
                            users_per_card_limit = 111, 
                            profiles = [
                                talon_one.models.loyalty_card_profile_registration.LoyaltyCardProfileRegistration(
                                    integration_id = 'R195412', 
                                    timestamp = '2021-09-12T10:12:42Z', )
                                ], 
                            ledger = talon_one.models.ledger_info.LedgerInfo(
                                current_balance = 100.0, 
                                pending_balance = 10.0, 
                                negative_balance = 10.0, 
                                expired_balance = 0.0, 
                                spent_balance = 0.0, 
                                tentative_current_balance = 100.0, 
                                tentative_pending_balance = 20.0, 
                                tentative_negative_balance = 100.0, 
                                current_tier = talon_one.models.tier.Tier(
                                    id = 11, 
                                    name = 'bronze', 
                                    start_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                    expiry_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                    downgrade_policy = 'one_down', ), 
                                points_to_next_tier = 20.0, ), 
                            subledgers = {
                                'key' : talon_one.models.ledger_info.LedgerInfo(
                                    current_balance = 100.0, 
                                    pending_balance = 10.0, 
                                    negative_balance = 10.0, 
                                    expired_balance = 0.0, 
                                    spent_balance = 0.0, 
                                    tentative_current_balance = 100.0, 
                                    tentative_pending_balance = 20.0, 
                                    tentative_negative_balance = 100.0, 
                                    points_to_next_tier = 20.0, )
                                }, 
                            modified = '2021-09-12T10:12:42Z', 
                            old_card_identifier = 'summer-loyalty-card-0543', 
                            new_card_identifier = 'summer-loyalty-card-0543', 
                            batch_id = 'wdefpov', )
                        ], 
                    programs = {
                        'key' : talon_one.models.loyalty_program_ledgers.LoyaltyProgramLedgers(
                            id = 5, 
                            title = 'My loyalty program', 
                            name = 'program1', 
                            join_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                            ledger = talon_one.models.ledger_info.LedgerInfo(
                                current_balance = 100.0, 
                                pending_balance = 10.0, 
                                negative_balance = 10.0, 
                                expired_balance = 0.0, 
                                spent_balance = 0.0, 
                                tentative_current_balance = 100.0, 
                                tentative_pending_balance = 20.0, 
                                tentative_negative_balance = 100.0, 
                                points_to_next_tier = 20.0, ), 
                            sub_ledgers = {
                                'key' : talon_one.models.ledger_info.LedgerInfo(
                                    current_balance = 100.0, 
                                    pending_balance = 10.0, 
                                    negative_balance = 10.0, 
                                    expired_balance = 0.0, 
                                    spent_balance = 0.0, 
                                    tentative_current_balance = 100.0, 
                                    tentative_pending_balance = 20.0, 
                                    tentative_negative_balance = 100.0, 
                                    points_to_next_tier = 20.0, )
                                }, )
                        }, ), 
                referrals = [
                    talon_one.models.inventory_referral.InventoryReferral(
                        id = 6, 
                        created = '2020-06-10T09:05:27.993483Z', 
                        start_date = '2020-11-10T23:00Z', 
                        expiry_date = '2021-11-10T23:00Z', 
                        usage_limit = 1, 
                        campaign_id = 78, 
                        advocate_profile_integration_id = 'URNGV8294NV', 
                        friend_profile_integration_id = 'BZGGC2454PA', 
                        attributes = {"channel":"web"}, 
                        import_id = 4, 
                        code = '27G47Y54VH9L', 
                        usage_counter = 1, 
                        batch_id = 'tqyrgahe', 
                        referred_customers = [
                            '0'
                            ], )
                    ], 
                coupons = [
                    talon_one.models.inventory_coupon.InventoryCoupon(
                        id = 6, 
                        created = '2020-06-10T09:05:27.993483Z', 
                        campaign_id = 211, 
                        value = 'XMAS-20-2021', 
                        usage_limit = 100, 
                        discount_limit = 30.0, 
                        reservation_limit = 45, 
                        start_date = '2020-01-24T14:15:22Z', 
                        expiry_date = '2023-08-24T14:15:22Z', 
                        limits = [
                            talon_one.models.limit_config.LimitConfig(
                                action = 'createCoupon', 
                                limit = 1000.0, 
                                period = 'yearly', 
                                entities = [Coupon], )
                            ], 
                        usage_counter = 10, 
                        discount_counter = 10.0, 
                        discount_remainder = 5.0, 
                        reservation_counter = 1.0, 
                        attributes = talon_one.models.attributes_of_coupon.Attributes of coupon(), 
                        referral_id = 326632952, 
                        recipient_integration_id = 'URNGV8294NV', 
                        import_id = 4, 
                        reservation = False, 
                        batch_id = '32535-43255', 
                        is_reservation_mandatory = False, 
                        implicitly_reserved = False, 
                        profile_redemption_count = 5, 
                        state = 'active', )
                    ], 
                giveaways = [
                    talon_one.models.giveaway.Giveaway(
                        id = 6, 
                        created = '2020-06-10T09:05:27.993483Z', 
                        code = 'GIVEAWAY1', 
                        pool_id = 1, 
                        start_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        end_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        attributes = talon_one.models.attributes.attributes(), 
                        used = True, 
                        import_id = 4, 
                        profile_integration_id = 'R195412', 
                        profile_id = 1, )
                    ], 
                achievements = [
                    talon_one.models.achievement_progress_with_definition.AchievementProgressWithDefinition(
                        status = 'completed', 
                        progress = 10.0, 
                        start_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        completion_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        end_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        achievement_id = 3, 
                        name = 'FreeCoffee10Orders', 
                        title = '50% off on 50th purchase.', 
                        description = '50% off for every 50th purchase in a year.', 
                        campaign_id = 3, 
                        target = 10.0, 
                        achievement_recurrence_policy = 'no_recurrence', 
                        achievement_activation_policy = 'fixed_schedule', 
                        achievement_fixed_start_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        achievement_end_date = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), )
                    ]
            )
        else :
            return CustomerInventory(
        )

    def testCustomerInventory(self):
        """Test CustomerInventory"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
