# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import talon_one
from talon_one.models.update_campaign_template import UpdateCampaignTemplate  # noqa: E501
from talon_one.rest import ApiException

class TestUpdateCampaignTemplate(unittest.TestCase):
    """UpdateCampaignTemplate unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test UpdateCampaignTemplate
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = talon_one.models.update_campaign_template.UpdateCampaignTemplate()  # noqa: E501
        if include_optional :
            return UpdateCampaignTemplate(
                name = 'Discount campaign', 
                description = 'This is a template for a discount campaign.', 
                instructions = 'Use this template for discount campaigns. Set the campaign properties according to the campaign goals, and don't forget to set an end date.', 
                campaign_attributes = None, 
                coupon_attributes = None, 
                state = 'draft', 
                active_ruleset_id = 5, 
                tags = [discount], 
                features = [
                    'coupons'
                    ], 
                coupon_settings = talon_one.models.code_generator_settings.CodeGeneratorSettings(
                    valid_characters = [A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 
                    coupon_pattern = 'SUMMER-####-####', ), 
                coupon_reservation_settings = talon_one.models.campaign_template_coupon_reservation_settings.CampaignTemplateCouponReservationSettings(
                    reservation_limit = 45, 
                    is_reservation_mandatory = False, ), 
                referral_settings = talon_one.models.code_generator_settings.CodeGeneratorSettings(
                    valid_characters = [A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 
                    coupon_pattern = 'SUMMER-####-####', ), 
                limits = [
                    talon_one.models.template_limit_config.TemplateLimitConfig(
                        action = 'createCoupon', 
                        limit = 1000.0, 
                        period = 'yearly', 
                        entities = [Coupon], )
                    ], 
                template_params = [
                    talon_one.models.campaign_template_params.CampaignTemplateParams(
                        name = 'discount_value', 
                        type = 'number', 
                        description = 'This is a template parameter of type `number`.', 
                        attribute_id = 42, )
                    ], 
                applications_ids = [1, 2, 3], 
                campaign_collections = [
                    talon_one.models.campaign_template_collection.CampaignTemplateCollection(
                        name = 'My collection', 
                        description = 'My collection of SKUs', )
                    ], 
                default_campaign_group_id = 42, 
                campaign_type = 'advanced'
            )
        else :
            return UpdateCampaignTemplate(
                name = 'Discount campaign',
                description = 'This is a template for a discount campaign.',
                instructions = 'Use this template for discount campaigns. Set the campaign properties according to the campaign goals, and don't forget to set an end date.',
                state = 'draft',
                applications_ids = [1, 2, 3],
        )

    def testUpdateCampaignTemplate(self):
        """Test UpdateCampaignTemplate"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
